/***************************************************************************
 *   Copyright (C) 2006 by Jean-Marc Vanel   *
 *   jmv@localhost.localdomain   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>
#include <fstream>
// #include <cstdlib>
#include "Vivant.h"
#include "Homme.h"

using namespace std;
void exemple_polymorphisme();


int main(int argc, char *argv[]) {
  exemple_polymorphisme();
  return EXIT_SUCCESS;
}

void exemple_polymorphisme() {
  cout << "Bonjour, monde!" << endl;

	Vivant* v = new Vivant;
	v->grandir();
	cout << "age : " << v->age() << "\n" << endl ;

	// manière standard
	Vivant* h = new Homme;
	h->grandir();
	cout << "age homme : " << h->age() << "\n" << endl ;

	delete h;
	delete v;

	// mauvaise pratique
	// ((Homme*)h )->diplomes;

	ofstream stream("sortie.txt");
	stream << "age homme : " << h->age() << "\n" << endl ;
	stream.flush();
}

 
